# Global_Macros.h File Reference

`#include "ace/ACE_export.h"`
`#include "ace/config-lite.h"`
`#include "ace/Assert.h"`
`#include "ace/OS_Errno.h"`

Include dependency graph for Global_Macros.h:

This graph shows which files directly or indirectly include this file:

## CORBA namespace macros.

CORBA namespace macros.

Deprecated:
  These macros were formerly used by TAO but are now deprecated, and only remain to retain some backward compatibility. They will be removed in a future ACE release.

#define | ACE_CORBA_1(NAME) CORBA::NAME
#define | ACE_CORBA_2(TYPE, NAME) CORBA::TYPE::NAME
#define | ACE_CORBA_3(TYPE, NAME) CORBA::TYPE::NAME

## Service Configurator macros

The following macros are used to define helper objects used in ACE's Service Configurator framework, which is described in Chapter 5 of C++NPv2 <www.cs.wustl.edu/~schmidt/ACE/book2/>. This framework implements the Component Configurator pattern, which is described in Chapter 2 of POSA2 <www.cs.wustl.edu/~schmidt/POSA/>. The intent of this pattern is to allow developers to dynamically load and configure services into a system. With a little help from this macros statically linked services can also be dynamically configured.

More details about this component are available in the documentation of the ACE_Service_Configurator class and also ACE_Dynamic_Service.

Notice that in all the macros the SERVICE_CLASS parameter must be the name of a class derived from ACE_Service_Object.

#define | ACE_STATIC_SVC_DECLARE(SERVICE_CLASS) extern ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS ;
#define | ACE_STATIC_SVC_DECLARE_EXPORT(EXPORT_NAME, SERVICE_CLASS) extern EXPORT_NAME##_Export ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS;
#define | ACE_STATIC_SVC_DEFINE(SERVICE_CLASS, NAME, TYPE, FN, FLAGS, ACTIVE) ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS = { NAME, TYPE, FN, FLAGS, ACTIVE };
#define | ACE_STATIC_SVC_REQUIRE(SERVICE_CLASS)
| Automatically register a service with the service configurator.
#define | ACE_STATIC_SVC_REGISTER(SERVICE_CLASS) do {} while (0)
#define | ACE_PREPROC_CONCATENATE_IMPL(A, B) A ## B
#define | ACE_PREPROC_CONCATENATE(A, B) ACE_PREPROC_CONCATENATE_IMPL(A,B)
#define | ACE_MAKE_SVC_CONFIG_FUNCTION_NAME(PREFIX, VERSIONED_NAMESPACE, SERVICE_CLASS) PREFIX ## _ ## SERVICE_CLASS
#define | ACE_MAKE_SVC_CONFIG_FACTORY_NAME(VERSIONED_NAMESPACE, SERVICE_CLASS) ACE_MAKE_SVC_CONFIG_FUNCTION_NAME(_make,VERSIONED_NAMESPACE,SERVICE_CLASS)
#define | ACE_MAKE_SVC_CONFIG_GOBBLER_NAME(VERSIONED_NAMESPACE, SERVICE_CLASS) ACE_MAKE_SVC_CONFIG_FUNCTION_NAME(_gobble,VERSIONED_NAMESPACE,SERVICE_CLASS)
#define | ACE_FACTORY_DECLARE(CLS, SERVICE_CLASS)
#define | ACE_Local_Service_Export
#define | ACE_FACTORY_DEFINE(CLS, SERVICE_CLASS)
#define | ACE_FACTORY_NAMESPACE_DEFINE(CLS, SERVICE_CLASS, NAMESPACE_CLASS)
#define | ACE_SVC_NAME(SERVICE_CLASS) ACE_MAKE_SVC_CONFIG_FACTORY_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS)
| The canonical name for a service factory method.
#define | ACE_SVC_INVOKE(SERVICE_CLASS) ACE_SVC_NAME(SERVICE_CLASS) (0)

## Helper macros for services defined in the netsvcs library.

The ACE services defined in netsvcs use this helper macros for simplicity.
#define | ACE_SVC_FACTORY_DECLARE(X) ACE_FACTORY_DECLARE (ACE_Svc, X)
#define | ACE_SVC_FACTORY_DEFINE(X) ACE_FACTORY_DEFINE (ACE_Svc, X)

## Defines

#define | ACE_BEGIN_DUMP ACE_LIB_TEXT ("\n====\n(%P|%t|%x)\n")
#define | ACE_END_DUMP ACE_LIB_TEXT ("====\n")
#define | ACE_DB(X) X
#define | ACE_NO_HEAP_CHECK
#define | ACE_ITOA(X) #X
#define | ACE_SERVER_ADDRESS(H, P) H ACE_TEXT(":") P
#define | ACE_POW(X) (((X) == 0)?1:(X-=1,X|=X>>1,X|=X>>2,X|=X>>4,X|=X>>8,X|=X>>16,(++X)))
#define | ACE_EVEN(NUM) (((NUM) & 1) == 0)
#define | ACE_ODD(NUM) (((NUM) & 1) == 1)
#define | ACE_BIT_ENABLED(WORD, BIT) (((WORD) & (BIT)) != 0)
#define | ACE_BIT_DISABLED(WORD, BIT) (((WORD) & (BIT)) == 0)
#define | ACE_BIT_CMP_MASK(WORD, BIT, MASK) (((WORD) & (BIT)) == MASK)
#define | ACE_SET_BITS(WORD, BITS) (WORD |= (BITS))
#define | ACE_CLR_BITS(WORD, BITS) (WORD &= ~(BITS))
#define | ACE_ENDLESS_LOOP
#define | ACE_UNIMPLEMENTED_FUNC(f) f;
#define | ACE_CLASS_IS_NAMESPACE(CLASSNAME)
#define | ACE_THROW_SPEC(X) throw X
#define | ACE_NESTED_CLASS(TYPE, NAME) TYPE::NAME
#define | ACE_GUARD_ACTION(MUTEX, OBJ, LOCK, ACTION, REACTION)
#define | ACE_GUARD_REACTION(MUTEX, OBJ, LOCK, REACTION) ACE_GUARD_ACTION(MUTEX, OBJ, LOCK, ;, REACTION)
#define | ACE_GUARD(MUTEX, OBJ, LOCK) ACE_GUARD_REACTION(MUTEX, OBJ, LOCK, return)
#define | ACE_GUARD_RETURN(MUTEX, OBJ, LOCK, RETURN) ACE_GUARD_REACTION(MUTEX, OBJ, LOCK, return RETURN)
#define | ACE_WRITE_GUARD(MUTEX, OBJ, LOCK)
#define | ACE_WRITE_GUARD_RETURN(MUTEX, OBJ, LOCK, RETURN)
#define | ACE_READ_GUARD(MUTEX, OBJ, LOCK)
#define | ACE_READ_GUARD_RETURN(MUTEX, OBJ, LOCK, RETURN)
#define | ACE_DES_NOFREE(POINTER, CLASS)
#define | ACE_DES_ARRAY_NOFREE(POINTER, SIZE, CLASS)
#define | ACE_DES_FREE(POINTER, DEALLOCATOR, CLASS)
#define | ACE_DES_ARRAY_FREE(POINTER, SIZE, DEALLOCATOR, CLASS)
#define | ACE_DES_NOFREE_TEMPLATE(POINTER, T_CLASS, T_PARAMETER)
#define | ACE_DES_ARRAY_NOFREE_TEMPLATE(POINTER, SIZE, T_CLASS, T_PARAMETER)
#define | ACE_DES_FREE_TEMPLATE(POINTER, DEALLOCATOR, T_CLASS, T_PARAMETER)
#define | ACE_DES_ARRAY_FREE_TEMPLATE(POINTER, SIZE, DEALLOCATOR, T_CLASS, T_PARAMETER)
#define | ACE_DES_FREE_TEMPLATE2(POINTER, DEALLOCATOR, T_CLASS, T_PARAM1, T_PARAM2)
#define | ACE_DES_FREE_TEMPLATE3(POINTER, DEALLOCATOR, T_CLASS, T_PARAM1, T_PARAM2, T_PARAM3)
#define | ACE_DES_FREE_TEMPLATE4(POINTER, DEALLOCATOR, T_CLASS, T_PARAM1, T_PARAM2, T_PARAM3, T_PARAM4)
#define | ACE_DES_ARRAY_FREE_TEMPLATE2(POINTER, SIZE, DEALLOCATOR, T_CLASS, T_PARAM1, T_PARAM2)
#define | ACE_ALLOCATOR_RETURN(POINTER, ALLOCATOR, RET_VAL)
#define | ACE_ALLOCATOR(POINTER, ALLOCATOR)
#define | ACE_ALLOCATOR_NORETURN(POINTER, ALLOCATOR)
#define | ACE_NEW_MALLOC_RETURN(POINTER, ALLOCATOR, CONSTRUCTOR, RET_VAL)
#define | ACE_NEW_MALLOC(POINTER, ALLOCATOR, CONSTRUCTOR)
#define | ACE_NEW_MALLOC_NORETURN(POINTER, ALLOCATOR, CONSTRUCTOR)
#define | ACE_NEW_MALLOC_ARRAY_RETURN(POINTER, ALLOCATOR, CONSTRUCTOR, COUNT, RET_VAL)
#define | ACE_NEW_MALLOC_ARRAY(POINTER, ALLOCATOR, CONSTRUCTOR, COUNT)
#define | ACE_NOOP(x)
#define | ACE_SEH_TRY if (1)
#define | ACE_SEH_EXCEPT(X) while (0)
#define | ACE_SEH_FINALLY if (1)
#define | ACE_SYNCH_DECL class _ACE_SYNCH
#define | ACE_SYNCH_USE _ACE_SYNCH
#define | ACE_SYNCH_MUTEX_T ACE_TYPENAME _ACE_SYNCH::MUTEX
#define | ACE_SYNCH_CONDITION_T ACE_TYPENAME _ACE_SYNCH::CONDITION
#define | ACE_SYNCH_SEMAPHORE_T ACE_TYPENAME _ACE_SYNCH::SEMAPHORE
#define | ACE_MEM_POOL_1 class _ACE_MEM_POOL
#define | ACE_MEM_POOL_2 _ACE_MEM_POOL
#define | ACE_MEM_POOL _ACE_MEM_POOL
#define | ACE_MEM_POOL_OPTIONS ACE_TYPENAME _ACE_MEM_POOL::OPTIONS
#define | ACE_PEER_STREAM_1 class _ACE_PEER_STREAM
#define | ACE_PEER_STREAM_2 _ACE_PEER_STREAM
#define | ACE_PEER_STREAM _ACE_PEER_STREAM
#define | ACE_PEER_STREAM_ADDR ACE_TYPENAME _ACE_PEER_STREAM::PEER_ADDR
#define | ACE_PEER_ACCEPTOR_1 class _ACE_PEER_ACCEPTOR
#define | ACE_PEER_ACCEPTOR_2 _ACE_PEER_ACCEPTOR
#define | ACE_PEER_ACCEPTOR _ACE_PEER_ACCEPTOR
#define | ACE_PEER_ACCEPTOR_ADDR ACE_TYPENAME _ACE_PEER_ACCEPTOR::PEER_ADDR
#define | ACE_PEER_CONNECTOR_1 class _ACE_PEER_CONNECTOR
#define | ACE_PEER_CONNECTOR_2 _ACE_PEER_CONNECTOR
#define | ACE_PEER_CONNECTOR _ACE_PEER_CONNECTOR
#define | ACE_PEER_CONNECTOR_ADDR ACE_TYPENAME _ACE_PEER_CONNECTOR::PEER_ADDR
#define | ACE_PEER_CONNECTOR_ADDR_ANY ACE_PEER_CONNECTOR_ADDR::sap_any
#define | ACE_SOCK_ACCEPTOR ACE_SOCK_Acceptor
#define | ACE_SOCK_CONNECTOR ACE_SOCK_Connector
#define | ACE_SOCK_STREAM ACE_SOCK_Stream
#define | ACE_SOCK_DGRAM ACE_SOCK_Dgram
#define | ACE_SOCK_DGRAM_BCAST ACE_SOCK_Dgram_Bcast
#define | ACE_SOCK_DGRAM_MCAST ACE_SOCK_Dgram_Mcast
#define | ACE_SOCK_SEQPACK_ACCEPTOR ACE_SOCK_SEQPACK_Acceptor
#define | ACE_SOCK_SEQPACK_CONNECTOR ACE_SOCK_SEQPACK_Connector
#define | ACE_SOCK_SEQPACK_ASSOCIATION ACE_SOCK_SEQPACK_Association
#define | ACE_MEM_ACCEPTOR ACE_MEM_Acceptor
#define | ACE_MEM_CONNECTOR ACE_MEM_Connector
#define | ACE_MEM_STREAM ACE_MEM_Stream
#define | ACE_LSOCK_ACCEPTOR ACE_LSOCK_Acceptor
#define | ACE_LSOCK_CONNECTOR ACE_LSOCK_Connector
#define | ACE_LSOCK_STREAM ACE_LSOCK_Stream
#define | ACE_TLI_ACCEPTOR ACE_TLI_Acceptor
#define | ACE_TLI_CONNECTOR ACE_TLI_Connector
#define | ACE_TLI_STREAM ACE_TLI_Stream
#define | ACE_SPIPE_ACCEPTOR ACE_SPIPE_Acceptor
#define | ACE_SPIPE_CONNECTOR ACE_SPIPE_Connector
#define | ACE_SPIPE_STREAM ACE_SPIPE_Stream
#define | ACE_UPIPE_ACCEPTOR ACE_UPIPE_Acceptor
#define | ACE_UPIPE_CONNECTOR ACE_UPIPE_Connector
#define | ACE_UPIPE_STREAM ACE_UPIPE_Stream
#define | ACE_FILE_CONNECTOR ACE_FILE_Connector
#define | ACE_FILE_STREAM ACE_FILE_IO
#define | ACE_MMAP_MEMORY_POOL ACE_MMAP_Memory_Pool
#define | ACE_LITE_MMAP_MEMORY_POOL ACE_Lite_MMAP_Memory_Pool
#define | ACE_SBRK_MEMORY_POOL ACE_Sbrk_Memory_Pool
#define | ACE_SHARED_MEMORY_POOL ACE_Shared_Memory_Pool
#define | ACE_LOCAL_MEMORY_POOL ACE_Local_Memory_Pool
#define | ACE_PAGEFILE_MEMORY_POOL ACE_Pagefile_Memory_Pool

## Typedefs

typedef void(* | ACE_Service_Object_Exterminator )(void *)

## Detailed Description

Id
  Global_Macros.h,v 4.46 2006/01/11 14:29:11 jtc Exp

Author:
  Douglas C. Schmidt <schmidt@cs.wustl.edu>

  Jesper S. M|ller<stophph@diku.dk>

  and a cast of thousands...

This one is split from the famous OS.h

## Define Documentation

#define ACE_ALLOCATOR | ( | POINTER,
|  | ALLOCATOR |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return; } \
       } while (0)

#define ACE_ALLOCATOR_NORETURN | ( | POINTER,
|  | ALLOCATOR |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; } \
       } while (0)

#define ACE_ALLOCATOR_RETURN | ( | POINTER,
|  | ALLOCATOR,
|  | RET_VAL |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return RET_VAL; } \
       } while (0)

#define ACE_BEGIN_DUMP ACE_LIB_TEXT ("\n====\n(%P|%t|%x)\n")

#define ACE_BIT_CMP_MASK | ( | WORD,
|  | BIT,
|  | MASK |  | ) | (((WORD) & (BIT)) == MASK)

#define ACE_BIT_DISABLED | ( | WORD,
|  | BIT |  | ) | (((WORD) & (BIT)) == 0)

#define ACE_BIT_ENABLED | ( | WORD,
|  | BIT |  | ) | (((WORD) & (BIT)) != 0)

#define ACE_CLASS_IS_NAMESPACE | ( | CLASSNAME |  | ) |

Value:

    private: \
      CLASSNAME (void); \
      CLASSNAME (const CLASSNAME&); \
      friend class ace_dewarn_gplusplus

#define ACE_CLR_BITS | ( | WORD,
|  | BITS |  | ) | (WORD &= ~(BITS))

#define ACE_CORBA_1 | ( | NAME |  | ) | CORBA::NAME

#define ACE_CORBA_2 | ( | TYPE,
|  | NAME |  | ) | CORBA::TYPE::NAME

#define ACE_CORBA_3 | ( | TYPE,
|  | NAME |  | ) | CORBA::TYPE::NAME

#define ACE_DB | ( | X |  | ) | X

#define ACE_DES_ARRAY_FREE | ( | POINTER,
|  | SIZE,
|  | DEALLOCATOR,
|  | CLASS |  | ) |

Value:

    do { \
            if (POINTER) \
              { \
                for (size_t i = 0; \
                     i < SIZE; \
                     ++i) \
                { \
                  (&(POINTER)[i])->~CLASS (); \
                } \
                DEALLOCATOR (POINTER); \
              } \
          } \
       while (0)

#define ACE_DES_ARRAY_FREE_TEMPLATE | ( | POINTER,
|  | SIZE,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAMETER |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    for (size_t i = 0; \
                         i < SIZE; \
                         ++i) \
                    { \
                      POINTER[i].T_CLASS T_PARAMETER::~T_CLASS (); \
                    } \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_ARRAY_FREE_TEMPLATE2 | ( | POINTER,
|  | SIZE,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAM1,
|  | T_PARAM2 |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    for (size_t i = 0; \
                         i < SIZE; \
                         ++i) \
                    { \
                      POINTER[i].T_CLASS <T_PARAM1, T_PARAM2>::~T_CLASS (); \
                    } \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_ARRAY_NOFREE | ( | POINTER,
|  | SIZE,
|  | CLASS |  | ) |

Value:

    do { \
            if (POINTER) \
              { \
                for (size_t i = 0; \
                     i < SIZE; \
                     ++i) \
                { \
                  (&(POINTER)[i])->~CLASS (); \
                } \
              } \
          } \
       while (0)

#define ACE_DES_ARRAY_NOFREE_TEMPLATE | ( | POINTER,
|  | SIZE,
|  | T_CLASS,
|  | T_PARAMETER |  | ) |

Value:

    do { \
              if (POINTER) \
                { \
                  for (size_t i = 0; \
                       i < SIZE; \
                       ++i) \
                  { \
                    (POINTER)[i].T_CLASS T_PARAMETER::~T_CLASS (); \
                  } \
                } \
            } \
         while (0)

#define ACE_DES_FREE | ( | POINTER,
|  | DEALLOCATOR,
|  | CLASS |  | ) |

Value:

    do { \
            if (POINTER) \
              { \
                (POINTER)->~CLASS (); \
                DEALLOCATOR (POINTER); \
              } \
          } \
       while (0)

#define ACE_DES_FREE_TEMPLATE | ( | POINTER,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAMETER |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    POINTER->T_CLASS T_PARAMETER::~T_CLASS (); \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_FREE_TEMPLATE2 | ( | POINTER,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAM1,
|  | T_PARAM2 |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    POINTER->T_CLASS <T_PARAM1, T_PARAM2>::~T_CLASS (); \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_FREE_TEMPLATE3 | ( | POINTER,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAM1,
|  | T_PARAM2,
|  | T_PARAM3 |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    POINTER->T_CLASS <T_PARAM1, T_PARAM2, T_PARAM3>::~T_CLASS (); \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_FREE_TEMPLATE4 | ( | POINTER,
|  | DEALLOCATOR,
|  | T_CLASS,
|  | T_PARAM1,
|  | T_PARAM2,
|  | T_PARAM3,
|  | T_PARAM4 |  | ) |

Value:

    do { \
                if (POINTER) \
                  { \
                    POINTER->T_CLASS <T_PARAM1, T_PARAM2, T_PARAM3, T_PARAM4>::~T_CLASS (); \
                    DEALLOCATOR (POINTER); \
                  } \
              } \
           while (0)

#define ACE_DES_NOFREE | ( | POINTER,
|  | CLASS |  | ) |

Value:

    do { \
            if (POINTER) \
              { \
                (POINTER)->~CLASS (); \
              } \
          } \
       while (0)

#define ACE_DES_NOFREE_TEMPLATE | ( | POINTER,
|  | T_CLASS,
|  | T_PARAMETER |  | ) |

Value:

    do { \
              if (POINTER) \
                { \
                  (POINTER)->T_CLASS T_PARAMETER::~T_CLASS (); \
                } \
            } \
         while (0)

#define ACE_END_DUMP ACE_LIB_TEXT ("====\n")

#define ACE_ENDLESS_LOOP

#define ACE_EVEN | ( | NUM |  | ) | (((NUM) & 1) == 0)

#define ACE_FACTORY_DECLARE | ( | CLS,
|  | SERVICE_CLASS |  | ) |

Value:

    extern "C" CLS##_Export ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object * \
    ACE_MAKE_SVC_CONFIG_FACTORY_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS) (ACE_Service_Object_Exterminator *);

Once the service implementation is dynamically loaded the Service Configurator uses a factory method to create the object. This macro declares such a factory function with the proper interface and export macros. Normally used in the header file that declares the service implementation.

Parameters:

  | CLS | must match the prefix of the export macro used for this service.
  | SERVICE_CLASS | must match the name of the class that implements the service.

#define ACE_FACTORY_DEFINE | ( | CLS,
|  | SERVICE_CLASS |  | ) |

Value:

    void ACE_MAKE_SVC_CONFIG_GOBBLER_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS) (void *p) { \
      ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object * _p = \
        static_cast< ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object *> (p); \
      ACE_ASSERT (_p != 0); \
      delete _p; } \
    extern "C" CLS##_Export ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object *\
    ACE_MAKE_SVC_CONFIG_FACTORY_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS) (ACE_Service_Object_Exterminator *gobbler) \
    { \
      ACE_TRACE (#SERVICE_CLASS); \
      if (gobbler != 0) \
        *gobbler = (ACE_Service_Object_Exterminator) ACE_MAKE_SVC_CONFIG_GOBBLER_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS); \
      return new SERVICE_CLASS; \
    }

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_FACTORY_NAMESPACE_DEFINE | ( | CLS,
|  | SERVICE_CLASS,
|  | NAMESPACE_CLASS |  | ) |

Value:

    void ACE_MAKE_SVC_CONFIG_GOBBLER_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS) (void *p) { \
      ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object * _p = \
        static_cast< ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object *> (p); \
      ACE_ASSERT (_p != 0); \
      delete _p; } \
    extern "C" CLS##_Export ACE_VERSIONED_NAMESPACE_NAME::ACE_Service_Object *\
    ACE_MAKE_SVC_CONFIG_FACTORY_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS) (ACE_Service_Object_Exterminator *gobbler) \
    { \
      ACE_TRACE (#SERVICE_CLASS); \
      if (gobbler != 0) \
        *gobbler = (ACE_Service_Object_Exterminator) ACE_MAKE_SVC_CONFIG_GOBBLER_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS); \
      return new NAMESPACE_CLASS; \
    }

For service classes scoped within namespaces, use this macro in place of ACE_FACTORY_DEFINE. The third argument in this case is the fully scoped name of the class as it is to be instantiated. For example, given: namespace ACE { namespace Foo { class Bar : public ACE_Service_Object {}; }; };

ACE_FACTORY_DECLARE(ACE,ACE_Foo_Bar)

you would then use:

ACE_FACTORY_NAMESPACE_DEFINE(ACE,ACE_Foo_Bar,ACE::Foo::Bar)

Note that in this example, the ACE_FACTORY_DECLARE is done outside the namespace scope. Then, the SERVICE_CLASS name is the same as the fully scoped class name, but with '::' replaced with '_'. Doing this will ensure unique generated signatures for the various C style functions.

#define ACE_FILE_CONNECTOR ACE_FILE_Connector

#define ACE_FILE_STREAM ACE_FILE_IO

#define ACE_GUARD | ( | MUTEX,
|  | OBJ,
|  | LOCK |  | ) | ACE_GUARD_REACTION(MUTEX, OBJ, LOCK, return)

#define ACE_GUARD_ACTION | ( | MUTEX,
|  | OBJ,
|  | LOCK,
|  | ACTION,
|  | REACTION |  | ) |

Value:

    ACE_Guard< MUTEX > OBJ (LOCK); \
       if (OBJ.locked () != 0) { ACTION; } \
       else { REACTION; }

#define ACE_GUARD_REACTION | ( | MUTEX,
|  | OBJ,
|  | LOCK,
|  | REACTION |  | ) | ACE_GUARD_ACTION(MUTEX, OBJ, LOCK, ;, REACTION)

#define ACE_GUARD_RETURN | ( | MUTEX,
|  | OBJ,
|  | LOCK,
|  | RETURN |  | ) | ACE_GUARD_REACTION(MUTEX, OBJ, LOCK, return RETURN)

#define ACE_ITOA | ( | X |  | ) | #X

#define ACE_LITE_MMAP_MEMORY_POOL ACE_Lite_MMAP_Memory_Pool

#define ACE_LOCAL_MEMORY_POOL ACE_Local_Memory_Pool

#define ACE_Local_Service_Export

| Use with arguments matching ACE_FACTORY_DECLARE. Normally used in the .cpp file that defines the service implementation. This macro defines both the factory method and the function used to cleanup the service object. If this macro is used to define a factory function that need not be exported (for example, in a static service situation), CLS can be specified as ACE_Local_Service.

#define ACE_LSOCK_ACCEPTOR ACE_LSOCK_Acceptor

#define ACE_LSOCK_CONNECTOR ACE_LSOCK_Connector

#define ACE_LSOCK_STREAM ACE_LSOCK_Stream

#define ACE_MAKE_SVC_CONFIG_FACTORY_NAME | ( | VERSIONED_NAMESPACE,
|  | SERVICE_CLASS |  | ) | ACE_MAKE_SVC_CONFIG_FUNCTION_NAME(_make,VERSIONED_NAMESPACE,SERVICE_CLASS)

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_MAKE_SVC_CONFIG_FUNCTION_NAME | ( | PREFIX,
|  | VERSIONED_NAMESPACE,
|  | SERVICE_CLASS |  | ) | PREFIX ## _ ## SERVICE_CLASS

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_MAKE_SVC_CONFIG_GOBBLER_NAME | ( | VERSIONED_NAMESPACE,
|  | SERVICE_CLASS |  | ) | ACE_MAKE_SVC_CONFIG_FUNCTION_NAME(_gobble,VERSIONED_NAMESPACE,SERVICE_CLASS)

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_MEM_ACCEPTOR ACE_MEM_Acceptor

#define ACE_MEM_CONNECTOR ACE_MEM_Connector

#define ACE_MEM_POOL _ACE_MEM_POOL

#define ACE_MEM_POOL_1 class _ACE_MEM_POOL

#define ACE_MEM_POOL_2 _ACE_MEM_POOL

#define ACE_MEM_POOL_OPTIONS ACE_TYPENAME _ACE_MEM_POOL::OPTIONS

#define ACE_MEM_STREAM ACE_MEM_Stream

#define ACE_MMAP_MEMORY_POOL ACE_MMAP_Memory_Pool

#define ACE_NESTED_CLASS | ( | TYPE,
|  | NAME |  | ) | TYPE::NAME

#define ACE_NEW_MALLOC | ( | POINTER,
|  | ALLOCATOR,
|  | CONSTRUCTOR |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return;} \
         else { (void) new (POINTER) CONSTRUCTOR; } \
       } while (0)

#define ACE_NEW_MALLOC_ARRAY | ( | POINTER,
|  | ALLOCATOR,
|  | CONSTRUCTOR,
|  | COUNT |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return;} \
         else { (void) new (POINTER) CONSTRUCTOR [COUNT]; } \
       } while (0)

#define ACE_NEW_MALLOC_ARRAY_RETURN | ( | POINTER,
|  | ALLOCATOR,
|  | CONSTRUCTOR,
|  | COUNT,
|  | RET_VAL |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return RET_VAL;} \
         else { (void) new (POINTER) CONSTRUCTOR [COUNT]; } \
       } while (0)

#define ACE_NEW_MALLOC_NORETURN | ( | POINTER,
|  | ALLOCATOR,
|  | CONSTRUCTOR |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM;} \
         else { (void) new (POINTER) CONSTRUCTOR; } \
       } while (0)

#define ACE_NEW_MALLOC_RETURN | ( | POINTER,
|  | ALLOCATOR,
|  | CONSTRUCTOR,
|  | RET_VAL |  | ) |

Value:

    do { POINTER = ALLOCATOR; \
         if (POINTER == 0) { errno = ENOMEM; return RET_VAL;} \
         else { (void) new (POINTER) CONSTRUCTOR; } \
       } while (0)

#define ACE_NO_HEAP_CHECK

#define ACE_NOOP | ( | x |  | ) |

#define ACE_ODD | ( | NUM |  | ) | (((NUM) & 1) == 1)

#define ACE_PAGEFILE_MEMORY_POOL ACE_Pagefile_Memory_Pool

#define ACE_PEER_ACCEPTOR _ACE_PEER_ACCEPTOR

#define ACE_PEER_ACCEPTOR_1 class _ACE_PEER_ACCEPTOR

#define ACE_PEER_ACCEPTOR_2 _ACE_PEER_ACCEPTOR

#define ACE_PEER_ACCEPTOR_ADDR ACE_TYPENAME _ACE_PEER_ACCEPTOR::PEER_ADDR

#define ACE_PEER_CONNECTOR _ACE_PEER_CONNECTOR

#define ACE_PEER_CONNECTOR_1 class _ACE_PEER_CONNECTOR

#define ACE_PEER_CONNECTOR_2 _ACE_PEER_CONNECTOR

#define ACE_PEER_CONNECTOR_ADDR ACE_TYPENAME _ACE_PEER_CONNECTOR::PEER_ADDR

#define ACE_PEER_CONNECTOR_ADDR_ANY ACE_PEER_CONNECTOR_ADDR::sap_any

#define ACE_PEER_STREAM _ACE_PEER_STREAM

#define ACE_PEER_STREAM_1 class _ACE_PEER_STREAM

#define ACE_PEER_STREAM_2 _ACE_PEER_STREAM

#define ACE_PEER_STREAM_ADDR ACE_TYPENAME _ACE_PEER_STREAM::PEER_ADDR

#define ACE_POW | ( | X |  | ) | (((X) == 0)?1:(X-=1,X|=X>>1,X|=X>>2,X|=X>>4,X|=X>>8,X|=X>>16,(++X)))

#define ACE_PREPROC_CONCATENATE | ( | A,
|  | B |  | ) | ACE_PREPROC_CONCATENATE_IMPL(A,B)

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_PREPROC_CONCATENATE_IMPL | ( | A,
|  | B |  | ) | A ## B

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_READ_GUARD | ( | MUTEX,
|  | OBJ,
|  | LOCK |  | ) |

Value:

    ACE_Read_Guard< MUTEX > OBJ (LOCK); \
        if (OBJ.locked () == 0) return;

#define ACE_READ_GUARD_RETURN | ( | MUTEX,
|  | OBJ,
|  | LOCK,
|  | RETURN |  | ) |

Value:

    ACE_Read_Guard< MUTEX > OBJ (LOCK); \
        if (OBJ.locked () == 0) return RETURN;

#define ACE_SBRK_MEMORY_POOL ACE_Sbrk_Memory_Pool

#define ACE_SEH_EXCEPT | ( | X |  | ) | while (0)

#define ACE_SEH_FINALLY if (1)

#define ACE_SEH_TRY if (1)

#define ACE_SERVER_ADDRESS | ( | H,
|  | P |  | ) | H ACE_TEXT(":") P

#define ACE_SET_BITS | ( | WORD,
|  | BITS |  | ) | (WORD |= (BITS))

#define ACE_SHARED_MEMORY_POOL ACE_Shared_Memory_Pool

#define ACE_SOCK_ACCEPTOR ACE_SOCK_Acceptor

#define ACE_SOCK_CONNECTOR ACE_SOCK_Connector

#define ACE_SOCK_DGRAM ACE_SOCK_Dgram

#define ACE_SOCK_DGRAM_BCAST ACE_SOCK_Dgram_Bcast

#define ACE_SOCK_DGRAM_MCAST ACE_SOCK_Dgram_Mcast

#define ACE_SOCK_SEQPACK_ACCEPTOR ACE_SOCK_SEQPACK_Acceptor

#define ACE_SOCK_SEQPACK_ASSOCIATION ACE_SOCK_SEQPACK_Association

#define ACE_SOCK_SEQPACK_CONNECTOR ACE_SOCK_SEQPACK_Connector

#define ACE_SOCK_STREAM ACE_SOCK_Stream

#define ACE_SPIPE_ACCEPTOR ACE_SPIPE_Acceptor

#define ACE_SPIPE_CONNECTOR ACE_SPIPE_Connector

#define ACE_SPIPE_STREAM ACE_SPIPE_Stream

#define ACE_STATIC_SVC_DECLARE | ( | SERVICE_CLASS |  | ) | extern ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS ;

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_STATIC_SVC_DECLARE_EXPORT | ( | EXPORT_NAME,
|  | SERVICE_CLASS |  | ) | extern EXPORT_NAME##_Export ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS;

NT compilers require the use of explicit directives to export and import symbols from a DLL. If you need to define a service in a dynamic library you should use this version instead. Normally ACE uses a macro to inject the correct export/import directives on NT. Naturally it also the macro expands to a blank on platforms that do not require such directives. The first argument (EXPORT_NAME) is the prefix for this export macro, the full name is formed by appending _Export. ACE provides tools to generate header files that define the macro correctly on all platforms, please see $ACE_ROOT/bin/generate_export_file.pl

Parameters:

  | EXPORT_NAME | The export macro name prefix.
  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_STATIC_SVC_DEFINE | ( | SERVICE_CLASS,
|  | NAME,
|  | TYPE,
|  | FN,
|  | FLAGS,
|  | ACTIVE |  | ) | ACE_Static_Svc_Descriptor ace_svc_desc_##SERVICE_CLASS = { NAME, TYPE, FN, FLAGS, ACTIVE };

The service configurator requires several arguments to build and control an statically linked service, including its name, the factory function used to construct the service, and some flags. All those parameters are configured in a single structure, an instance of this structure is statically initialized using the following macro.

Parameters:

  | SERVICE_CLASS | The name of the class that implements the service, must be derived (directly or indirectly) from ACE_Service_Object.
  | NAME | The name for this service, this name is used by the service configurator to match configuration options provided in the svc.conf file.
  | TYPE | The type of object. Objects can be streams or service objects. Please read the ACE_Service_Configurator and ASX documentation for more details.
  | FN | The name of the factory function, usually the ACE_SVC_NAME macro can be used to generate the name. The factory function is often defined using ACE_FACTORY_DECLARE and ACE_FACTORY_DEFINE.
  | FLAGS | Flags to control the ownership and lifecycle of the object. Please read the ACE_Service_Configurator documentation for more details.
  | ACTIVE | If not zero then a thread will be dedicate to the service. Please read the ACE_Service_Configurator documentation for more details.

#define ACE_STATIC_SVC_REGISTER | ( | SERVICE_CLASS |  | ) | do {} while (0)

The macro should be used in the header file where the service is declared, its only argument is usually the name of the class that implements the service.

Parameters:

  | SERVICE_CLASS | The name of the class implementing the service.

#define ACE_STATIC_SVC_REQUIRE | ( | SERVICE_CLASS |  | ) |

Value:

    class ACE_Static_Svc_##SERVICE_CLASS {\
    public:\
      ACE_Static_Svc_##SERVICE_CLASS() { \
        ACE_Service_Config::static_svcs ()->insert (\
             &ace_svc_desc_##SERVICE_CLASS); \
        } \
    };\
    static ACE_Static_Svc_##SERVICE_CLASS ace_static_svc_##SERVICE_CLASS;

Automatically register a service with the service configurator.

In some applications the services must be automatically registered with the service configurator, before main() starts. The ACE_STATIC_SVC_REQUIRE macro defines a class whose constructor register the service, it also defines a static instance of that class to ensure that the service is registered before main.

On platforms that lack adequate support for static C++ objects the macro ACE_STATIC_SVC_REGISTER can be used to explicitly register the service.

Todo:
  One class per-Service_Object seems wasteful. It should be possible to define a single class and re-use it for all the service objects, just by passing the Service_Descriptor as an argument to the constructor.

#define ACE_SVC_FACTORY_DECLARE | ( | X |  | ) | ACE_FACTORY_DECLARE (ACE_Svc, X)

#define ACE_SVC_FACTORY_DEFINE | ( | X |  | ) | ACE_FACTORY_DEFINE (ACE_Svc, X)

#define ACE_SVC_INVOKE | ( | SERVICE_CLASS |  | ) | ACE_SVC_NAME(SERVICE_CLASS) (0)

| The canonical way to invoke (i.e. construct) a service factory method.

#define ACE_SVC_NAME | ( | SERVICE_CLASS |  | ) | ACE_MAKE_SVC_CONFIG_FACTORY_NAME(ACE_VERSIONED_NAMESPACE_NAME,SERVICE_CLASS)

| The canonical name for a service factory method.

#define ACE_SYNCH_CONDITION_T ACE_TYPENAME _ACE_SYNCH::CONDITION

#define ACE_SYNCH_DECL class _ACE_SYNCH

#define ACE_SYNCH_MUTEX_T ACE_TYPENAME _ACE_SYNCH::MUTEX

#define ACE_SYNCH_SEMAPHORE_T ACE_TYPENAME _ACE_SYNCH::SEMAPHORE

#define ACE_SYNCH_USE _ACE_SYNCH

#define ACE_THROW_SPEC | ( | X |  | ) | throw X

#define ACE_TLI_ACCEPTOR ACE_TLI_Acceptor

#define ACE_TLI_CONNECTOR ACE_TLI_Connector

#define ACE_TLI_STREAM ACE_TLI_Stream

#define ACE_UNIMPLEMENTED_FUNC | ( | f |  | ) | f;

#define ACE_UPIPE_ACCEPTOR ACE_UPIPE_Acceptor

#define ACE_UPIPE_CONNECTOR ACE_UPIPE_Connector

#define ACE_UPIPE_STREAM ACE_UPIPE_Stream

#define ACE_WRITE_GUARD | ( | MUTEX,
|  | OBJ,
|  | LOCK |  | ) |

Value:

    ACE_Write_Guard< MUTEX > OBJ (LOCK); \
        if (OBJ.locked () == 0) return;

#define ACE_WRITE_GUARD_RETURN | ( | MUTEX,
|  | OBJ,
|  | LOCK,
|  | RETURN |  | ) |

Value:

    ACE_Write_Guard< MUTEX > OBJ (LOCK); \
        if (OBJ.locked () == 0) return RETURN;

## Typedef Documentation

typedef void(* ACE_Service_Object_Exterminator)(void *)

| Service Objects, i.e., objects dynamically loaded via the service configurator, must provide a destructor function with the following prototype to perform object cleanup.